package com.zeocollect;

import androidx.annotation.NonNull;

import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableMap;
import com.facebook.react.module.annotations.ReactModule;
import com.zeotap.collect.Collect;

@ReactModule(name = ZeoCollectModule.NAME)
public class ZeoCollectModule extends ReactContextBaseJavaModule {
    public static final String NAME = "ZeoCollectModule";

    Collect collect;

    public ZeoCollectModule(ReactApplicationContext reactContext) {
        super(reactContext);
        collect = Collect.getInstance();
    }

    @Override
    @NonNull
    public String getName() {
        return NAME;
    }

    @ReactMethod
    public void setEventNameProperties(String eventName) {
        collect.setEventProperties(eventName);
    }

    @ReactMethod
    public void setEventProperties(String eventName, ReadableMap eventProp) {
        collect.setEventProperties(eventName, eventProp.toHashMap());
    }

    @ReactMethod
    public void setInstantEventNameProperties(String eventName) {
        collect.setInstantEventProperties(eventName);
    }

    @ReactMethod
    public void setInstantEventProperties(String eventName, ReadableMap eventProp) {
        collect.setInstantEventProperties(eventName, eventProp.toHashMap());
    }

    @ReactMethod
    public void setUserIdentities(ReadableMap userProp) {
        collect.setUserIdentities(userProp.toHashMap());
    }

    @ReactMethod
    public void setUserProperties(ReadableMap userProp) {
        collect.setUserProperties(userProp.toHashMap());
    }

    @ReactMethod
    public void setPageProperties(ReadableMap properties) {
        collect.setPageProperties(properties.toHashMap());
    }

    @ReactMethod
    public void unsetUserIdentities() {
        collect.unsetUserIdentities();
    }

    @ReactMethod
    public void deInitiate() {
        collect.pauseCollection();
    }

    @ReactMethod
    public void reInitialize() {
        collect.resumeCollection();
    }

    @ReactMethod
    public void setConsent(ReadableMap consent) {
        collect.setConsent(consent.toHashMap());
    }

    @ReactMethod
    public void addAskForConsentListener(Callback cb) {
        collect.listenToAskForConsent((data) -> cb.invoke());
    }

    @ReactMethod
    public void getZI(Callback cb) {
        String zi = collect.getZI();
        cb.invoke(zi);
    }

    @ReactMethod
    public void resetZI() {
        collect.resetZI();
    }
}
